unit StealthPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TStealthPanel = class(TPanel)
  private
    { Private declarations }
    HideMode: Boolean;
  protected
    { Protected declarations }
    procedure CreateWnd; override;
  public
    { Public declarations }
    procedure HideItself;
    procedure ShowItself;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('RichView', [TStealthPanel]);
end;

{ TStealthPanel }

procedure TStealthPanel.CreateWnd;
begin
  inherited;
  if HideMode then HideItself;
end;

procedure TStealthPanel.HideItself;
var PanelRgn, ChildRgn: HRGN;
    i: Integer;
begin
  HideMode := True;
  if ControlCount=0 then begin
    Visible := False;
    exit;
  end;
  with Controls[0] do
    PanelRgn := CreateRectRgn(Left,Top,Left+Width,Top+Height);
  for i := 1 to ControlCount-1 do begin
    with Controls[i] do
      ChildRgn := CreateRectRgn(Left,Top,Left+Width,Top+Height);
    CombineRgn(PanelRgn,PanelRgn,ChildRgn, RGN_OR);
    DeleteObject(ChildRgn);
  end;
  Visible := True;  
  SetWindowRgn(Handle, PanelRgn, True);
end;

procedure TStealthPanel.ShowItself;
begin
  HideMode := False;
  SetWindowRgn(Handle, 0, True);
  Visible := True;
end;

end.
